/**********************************************************************
 *<
	FILE: afregion.cpp

	DESCRIPTION:  Affect region modifier

	CREATED BY: Rolf Berteig

	HISTORY: 10/16/96

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/

#include "mods.h"
#include "iparamm.h"

#define PBLOCK_REF	0
//#define POINT1_REF	1
//#define SELFNODE_REF	2
#define LAZYID 0xDE17A346, 0x8A41E2Ab





class NullView: public View {
	public:
		Point2 ViewToScreen(Point3 p) { return Point2(p.x,p.y); }
		NullView() { worldToView.IdentityMatrix(); screenW=640.0f; screenH = 480.0f; }
	};


class PaintMode;

class AFRMod : public Modifier {	
	public:
		IParamBlock *pblock;
		static PaintMode *paintMode;

		Tab<Point3> DeltaList;
		Tab<Point3> TempList;
		Tab<BOOL> SelectVertList;
		int SelectMode;

//		Control *p1;
		BYTE sel[1];

		static IObjParam *ip;
		static IParamMap *pmapParam;
		
		AFRMod();
		~AFRMod() {
				DeleteAllRefsFromMe();
				pblock = NULL;
//				p1 = NULL;
				}

static	float strength, eradius;
		float strengthsquared,eradiussquared;
static	float hardness;
static	float effect;
		int Addative;
		IPoint2 pp;

		HWND inkHWND;
static		int inkType;


		// From Animatable
		void DeleteThis() { delete this; }
		void GetClassName(TSTR& s) {s = GetString(IDS_RB_AFRMOD);}  
		virtual Class_ID ClassID() { return Class_ID(LAZYID);}		
		void BeginEditParams(IObjParam  *ip, ULONG flags,Animatable *prev);
		void EndEditParams(IObjParam *ip,ULONG flags,Animatable *next);		
		RefTargetHandle Clone(RemapDir& remap = NoRemap());
		TCHAR *GetObjectName() {return GetString(IDS_RB_AFRMOD);}

		// From modifier
		ChannelMask ChannelsUsed()  {return PART_GEOM|PART_TOPO|PART_SELECT|PART_SUBSEL_TYPE;}
		ChannelMask ChannelsChanged() {return PART_GEOM;}
		Class_ID InputType() {return defObjectClassID;}
		void ModifyObject(TimeValue t, ModContext &mc, ObjectState *os, INode *node);
		Interval LocalValidity(TimeValue t);

		// From BaseObject
//		int HitTest(TimeValue t, INode* inode, int type, int crossing, int flags, IPoint2 *p, ViewExp *vpt, ModContext* mc);
//		int Display(TimeValue t, INode* inode, ViewExp *vpt, int flagst, ModContext *mc);
//		void GetWorldBoundBox(TimeValue t,INode* inode, ViewExp *vpt, Box3& box, ModContext *mc);		
//		void Move( TimeValue t, Matrix3& partm, Matrix3& tmAxis, Point3& val, BOOL localOrigin=FALSE );
		CreateMouseCallBack* GetCreateMouseCallBack() {return NULL;} 
//		void GetSubObjectCenters(SubObjAxisCallback *cb,TimeValue t,INode *node,ModContext *mc);
//		void GetSubObjectTMs(SubObjAxisCallback *cb,TimeValue t,INode *node,ModContext *mc);
//		void ActivateSubobjSel(int level, XFormModes& modes);
//		void SelectSubComponent(HitRecord *hitRec, BOOL selected, BOOL all, BOOL invert=FALSE);
//		void ClearSelection(int selLevel);
//		void SelectAll(int selLevel);
//		void InvertSelection(int selLevel);

		int NumRefs() {return 1;}
		RefTargetHandle GetReference(int i);
		void SetReference(int i, RefTargetHandle rtarg);

		int NumSubs() {return 1;}
		Animatable* SubAnim(int i){return pblock;}; 
		TSTR SubAnimName( int i  ) {return TSTR(GetString(IDS_RB_PARAMETERS));};

		RefResult NotifyRefChanged( Interval changeInt,RefTargetHandle hTarget, 
		   PartID& partID, RefMessage message);

//		Matrix3 CompMatrix(TimeValue t,INode *inode,ModContext *mc);


		void EnterNormalAlign();
		void ExitNormalAlign();

		IOResult Load(ILoad *iload);
		IOResult Save(ISave *isave);


	};

float AFRMod::strength = 2.0f;
float AFRMod::eradius = 30.0f;
float AFRMod::hardness = 1.0f;
float AFRMod::effect = 1.0f;
int AFRMod::inkType = 0;



class AFRUndoList
{
public:
int vertindex;
Point3 delta;
};

// A restore object to save the position of control points.
class MoveRestore : public RestoreObj {
	public:		
		AFRMod *mod;
		Tab<AFRUndoList> PListUndo;
//		Tab<AFRUndoList> PListRedo;
		MoveRestore(AFRMod *m) {
			mod = m;
			PListUndo.ZeroCount();
			for (int i=0; i<mod->TempList.Count(); i++) {
				if (Length(mod->TempList[i]) > 0.000f)
					{
					AFRUndoList t;
					t.vertindex = i;
					t.delta = mod->TempList[i];
					PListUndo.Append(1,&t,1);
//					PListRedo.Append(1,&t,1);
					}
				}
			}

		void Restore(int isUndo) {
			// if we're undoing, save a redo state
/*			if (isUndo) {
				for (int i=0; i<mod->NumCtrlPts(); i++) {
					redo[i] = mod->GetPt(i);
					}
				}
*/
			if (isUndo) {
				for (int i=0; i<PListUndo.Count(); i++) {
					mod->DeltaList[PListUndo[i].vertindex] -= PListUndo[i].delta;
//					mod->GetPt(i) = undo[i];
					}
				mod->NotifyDependents(FOREVER,PART_GEOM,REFMSG_CHANGE);
				}
			}

		void Redo() {
			for (int i=0; i<PListUndo.Count(); i++) {
				mod->DeltaList[PListUndo[i].vertindex] += PListUndo[i].delta;
//				mod->GetPt(i) = undo[i];
				}
//			for (int i=0; i<mod->NumCtrlPts(); i++) {
//				mod->GetPt(i) = redo[i];
//				}
			mod->NotifyDependents(FOREVER,PART_GEOM,REFMSG_CHANGE);
			}
//		void EndHold() {
//			mod->ClearAFlag(A_HELD);
//			}
	TSTR Description()

		{ return TSTR(_T("Paint Deform")); }
	};




// Flags
#define CONTROL_FIT			(1<<0)
#define CONTROL_CENTER		(1<<1)
#define CONTROL_ASPECT		(1<<2)
#define CONTROL_UNIFORM		(1<<3)
#define CONTROL_HOLD		(1<<4)
#define CONTROL_INIT		(1<<5)
#define CONTROL_OP			(CONTROL_FIT|CONTROL_CENTER|CONTROL_ASPECT|CONTROL_UNIFORM)
#define CONTROL_INITPARAMS	(1<<10)


#define CID_FACEALIGNMAP 	0x4f298c7a
#define CID_REGIONFIT 		0x4f298c7b


class PaintMouseProc : public MouseCallBack {
	public:
		AFRMod *mod;
		IObjParam *ip;
		PaintMouseProc(AFRMod *m,IObjParam *i) {mod=m;ip=i;}
		int proc(HWND hWnd, int msg, int point, int flags, IPoint2 m);
		void PaintMap(HWND hWnd,IPoint2 m);
	};

class PaintMode : public CommandMode {
	public:
		ChangeFGObject fgProc;
		PaintMouseProc proc;
		IObjParam *ip;
		AFRMod *mod;

		PaintMode(AFRMod *m,IObjParam *i) 
			: fgProc(m), proc(m,i) {ip=i;mod=m;}

		int Class() {return MOVE_COMMAND;}		
		int ID() {return CID_FACEALIGNMAP;}
		MouseCallBack *MouseProc(int *numPoints) {*numPoints=2;return &proc;}
		ChangeForegroundCallback *ChangeFGProc() {return &fgProc;}
		BOOL ChangeFG(CommandMode *oldMode) {return oldMode->ChangeFGProc() != &fgProc;}
		void EnterMode();
		void ExitMode();
	};



PaintMode*      AFRMod::paintMode = NULL;


static void MatrixFromNormal(Point3& normal, Matrix3& mat)
	{
	Point3 vx;
	vx.z = .0f;
	vx.x = -normal.y;
	vx.y = normal.x;	
	if ( vx.x == .0f && vx.y == .0f ) {
		vx.x = 1.0f;
		}
	mat.SetRow(0,vx);
	mat.SetRow(1,normal^vx);
	mat.SetRow(2,normal);
	mat.SetTrans(Point3(0,0,0));
	mat.NoScale();
	}

void PaintMouseProc::PaintMap(HWND hWnd,IPoint2 m)
	{
ViewExp *vpt = ip->GetViewport(hWnd);
if (!vpt) return;

Ray ray, wray;
float at;
TimeValue t = ip->GetTime();	
Point3 norm, pt;
Interval valid;
BOOL changed = FALSE;	

	// Get mod contexts and nodes for this modifier
ModContextList mcList;
INodeTab nodeList;
ip->GetModContexts(mcList,nodeList);

	// Calculate a ray from the mouse point
int dist;
IPoint2 inc; 
/*
if (!mod->Addative)
	{
	dist = Length(m-mod->pp)/(int)(mod->eradius*5) +1;
	inc = (m-mod->pp)/dist;
	}
else
	{*/
	dist = Length(m-mod->pp)/(int)mod->eradius +1;
	inc = (m-mod->pp)/dist;
//	}

	
mod->pp = m;

Tab<Matrix3> obtm,iobtm;
Tab<Point3> xynorm,znorm,xynormlocal;
Tab<Ray> rray;
float pirad;

pirad = 3.14f/mod->eradius;


for (int i=0; i<nodeList.Count(); i++) {
	INode *node = nodeList[i];




// Back transform the ray into object space.		

	Matrix3 tobtm  = node->GetObjectTM(t);
	Matrix3 tiobtm = Inverse(tobtm);

	obtm.Append(1,&tobtm,1);
	iobtm.Append(1,&tiobtm,1);

//xynorm
	Matrix3 TM;
	vpt->GetAffineTM(TM);
	Matrix3 invTM = Inverse(TM);
	Point3 txynorm;
	txynorm.x = (float) inc.x;
	txynorm.y = -(float) inc.y;
	txynorm.z = 0.0f;
	txynorm = VectorTransform(invTM, txynorm);
	txynorm = VectorTransform(tiobtm,txynorm);
	txynorm = Normalize(txynorm)*mod->strength;
	xynorm.Append(1,&txynorm,1);
//move z
	Ray tempray;
	vpt->MapScreenToWorldRay(float(m.x), float(m.y),tempray);

	Ray tempray2;
	tempray2.dir = VectorTransform(tiobtm, tempray.dir);
	rray.Append(1,&tempray2,1);

	Point3 tznorm;
	tznorm = VectorTransform(tiobtm,tempray.dir);
	tznorm = -Normalize(tznorm)*mod->strength;
	znorm.Append(1,&tznorm,1);

	}




for (int j = 0;j < dist;j++)
	{
	vpt->MapScreenToWorldRay(float(m.x), float(m.y),wray);
	
	
	for (int i=0; i<nodeList.Count(); i++) {

		GeomObject *obj;

	// Get the object from the node
		INode *node = nodeList[i];

		ObjectState os = node->EvalWorldState(t);
		if (os.obj->SuperClassID()==GEOMOBJECT_CLASS_ID) {
			obj = (GeomObject*)os.obj;
		} else {
			continue;
			}


		ray.p   = iobtm[i] * wray.p;
		ray.dir = rray[i].dir;
	
		// See if we hit the object
		if (obj->IntersectRay(t,ray,at,norm)) {


			// Calculate the hit point
			pt = ray.p + ray.dir * at;

			Point3 nnorm(0.0f,0.0f,0.0f);
//move normal
			if (mod->inkType == 0)
				nnorm = Normalize(norm)*mod->strength;
//move xy
			else if (mod->inkType == 1)
				{
				nnorm = xynorm[i];
				}
//move z
			else if (mod->inkType == 2)
				{
				nnorm = znorm[i];

				}
//move x local
			else if (mod->inkType == 3)
				{
				nnorm.x = mod->strength;
				nnorm.y = 0.0f;
				nnorm.z = 0.0f;

				}
//move y local
			else if (mod->inkType == 3)
				{
				nnorm.y = mod->strength;
				nnorm.x = 0.0f;
				nnorm.z = 0.0f;

				}
//move z local
			else if (mod->inkType == 4)
				{
				nnorm.z = mod->strength;
				nnorm.x = 0.0f;
				nnorm.y = 0.0f;

				}
//smooth
			else if (mod->inkType == 5)
				{
				nnorm.z = 0.0f;
				nnorm.x = 0.0f;
				nnorm.y = 0.0f;

				}
//tesselate
			else if (mod->inkType == 6)
				{

				}
//select
			else if (mod->inkType == 7)
				{

				}

			
			float minx,maxx,miny,maxy,minz,maxz;
			minx = pt.x - mod->eradius; 
			miny = pt.y - mod->eradius;
			minz = pt.z - mod->eradius;

			maxx = pt.x + mod->eradius; 
			maxy = pt.y + mod->eradius;
			maxz = pt.z + mod->eradius;

			for (int vc = 0; vc < obj->NumPoints();vc++)

				{
//look bounding box
				Point3 p = obj->GetPoint(vc);
				if ( (p.x >= minx)  && (p.x <= maxx) &&
					 (p.y >= miny)  && (p.y <= maxy) && 
					 (p.z >= minz)  && (p.z <= maxz) ) 
					{
					float d = Length(pt-p);
					if (d <mod->eradius)
						{
						if (mod->inkType<6)
							{
							if (vc < mod->DeltaList.Count())
								{
								float f,f1;
								f = ((float)cos(d*pirad) + 1.0f)/2.0f;
								f1 = (1.0f-d/mod->eradius);
//DebugPrint("f %f f1 %f \n",f,f1);
								f = (f*(1.0f-mod->hardness))+ (f1*(mod->hardness));
						
//						mod->DeltaList[vc] += (nnorm * f);
//if addative check distance
								mod->TempList[vc] += (nnorm * f);
								if (!mod->Addative)
									{
									if (Length(mod->TempList[vc]) > mod->strengthsquared)
										mod->TempList[vc] = Normalize(mod->TempList[vc]) * mod->strength;
	
									}	


								changed = TRUE;
								}
							}
//select ink
						else if (mod->inkType ==7)
							{
							if (mod->SelectMode & MOUSE_ALT)
								{
								mod->SelectVertList[vc] = FALSE;
								changed = TRUE;
								}
							else 
								{
								mod->SelectVertList[vc] = TRUE;
								changed = TRUE;
								}
							

							}
						}
					}
				}
			break;
			}

		}
	m -= inc;
	}
nodeList.DisposeTemporary();
ip->ReleaseViewport(vpt);
if (changed)
	{

	if (mod->inkType<6)
		{
  
		mod->NotifyDependents(Interval(t,t), PART_GEOM, REFMSG_MOD_EVAL);
		}
	if (mod->inkType==7)
		{
		mod->NotifyDependents(Interval(t,t), PART_SELECT, REFMSG_MOD_EVAL);
		mod->NotifyDependents(Interval(t,t), PART_SUBSEL_TYPE, REFMSG_MOD_EVAL);
		mod->NotifyDependents(Interval(t,t), PART_DISPLAY, REFMSG_MOD_EVAL);
		}
	}

}

int PaintMouseProc::proc(
		HWND hWnd, int msg, int point, int flags, IPoint2 m)
	{
	int i;
	Point3 p(0.0f,0.0f,0.0f);
	switch (msg) {
		case MOUSE_POINT:
			if (point==0) {		
				mod->pp = m;
//				theHold.Begin();
				for (i = 0; i < mod->DeltaList.Count(); i++)
					{
					mod->TempList[i] = p;
					}
				mod->SelectMode = flags;
				if ((!(flags & MOUSE_ALT)) && (!(flags & MOUSE_CTRL)))
					{
					if (mod->inkType == 7)
						{
						for (i = 0; i < mod->SelectVertList.Count(); i++)
							{
							mod->SelectVertList[i] = FALSE;
							}
						}

					}
				ip->RedrawViews(ip->GetTime(),REDRAW_BEGIN);
			} else {
//add hold here
				if (!theHold.Holding() ) {
					theHold.Begin();
					}

				theHold.Put(new MoveRestore(mod));
//				theHold.Accept(IDS_RB_AFRMOD);
				theHold.Accept(TSTR(_T("Paint Deform")));
				

//					}
				for (i = 0; i < mod->DeltaList.Count(); i++)
					{
					mod->DeltaList[i] += mod->TempList[i];
					mod->TempList[i] = p;
					}

				ip->RedrawViews(ip->GetTime(),REDRAW_END);
				}
			break;

		case MOUSE_MOVE: {
//			theHold.Restore();
			PaintMap(hWnd,m);
			ip->RedrawViews(ip->GetTime(),REDRAW_INTERACTIVE);			
			break;
			}

		case MOUSE_ABORT:
//			theHold.Cancel();
			for (i = 0; i < mod->DeltaList.Count(); i++)
				{
				mod->TempList[i] = p;
				}
			mod->NotifyDependents(Interval(ip->GetTime(),ip->GetTime()), PART_GEOM, REFMSG_MOD_EVAL);

			ip->RedrawViews(ip->GetTime(),REDRAW_END);
			break;

		case MOUSE_FREEMOVE:			
			SetCursor(ip->GetSysCursor(SYSCUR_SELECT));
			break;
		}
	return TRUE;
	}

void PaintMode::EnterMode()
	{
	mod->EnterNormalAlign();	
DebugPrint("Enetr mode\n");
	}

void PaintMode::ExitMode()
	{
	mod->ExitNormalAlign();	
	}




class AFRDeformer : public Deformer {
	public:		

		AFRMod *mod;
		AFRDeformer(AFRMod *m) {mod = m;}
		Point3 Map(int i, Point3 p);
	};


//--- ClassDescriptor and class vars ---------------------------------

IParamMap       *AFRMod::pmapParam = NULL;
IObjParam       *AFRMod::ip        = NULL;
		

class AFRClassDesc:public ClassDesc {
	public:
	int 			IsPublic() { return 1; }
	void *			Create(BOOL loading = FALSE) { return new AFRMod; }
	const TCHAR *	ClassName() { return GetString(IDS_RB_PMOD); }
	SClass_ID		SuperClassID() { return OSM_CLASS_ID; }
	Class_ID		ClassID() { return Class_ID(LAZYID); }
	const TCHAR* 	Category() { return GetString(IDS_RB_DEFDEFORMATIONS);}
	};

static AFRClassDesc afrDesc;
extern ClassDesc* GetAFRModDesc() {return &afrDesc;}


//--- Parameter map/block descriptors -------------------------------

#define PB_STR			0
#define PB_ERADIUS		1
#define PB_HARDNESS		2
#define PB_ADDATIVE		3
#define PB_EFFECT		4

//
//
// Parameters

static ParamUIDesc descParam[] = {
	// Falloff
	ParamUIDesc(
		PB_STR,
		EDITTYPE_FLOAT,
		IDC_AFR_STR,IDC_AFR_STRSPIN,
		-BIGFLOAT,BIGFLOAT,
		SPIN_AUTOSCALE),

	// Settle
	ParamUIDesc(
		PB_ERADIUS,
		EDITTYPE_FLOAT,
		IDC_AFR_ERADIUS,IDC_AFR_ERADIUS_SPIN,
		0.0f,BIGFLOAT,
		SPIN_AUTOSCALE),

	// Waves
	ParamUIDesc(
		PB_HARDNESS,
		EDITTYPE_FLOAT,
		IDC_AFR_HARDNESS,IDC_AFR_HARDNESS_SPIN,
		0.0f,1.0f,
		SPIN_AUTOSCALE),

	// Addative
   ParamUIDesc(PB_ADDATIVE,TYPE_SINGLECHEKBOX,IDC_ADDATIVE),

	// Effect
	ParamUIDesc(
		PB_EFFECT,
		EDITTYPE_FLOAT,
		IDC_AFR_EFFECT,IDC_AFR_EFFECT_SPIN,
		-5.0f,5.0f,
		SPIN_AUTOSCALE),


	};
#define PARAMDESC_LENGTH	5

static ParamBlockDescID descVer0[] = {
	{ TYPE_FLOAT, NULL, FALSE,  0 },		// Falloff	
	{ TYPE_FLOAT, NULL, FALSE,  1 },		// Settle	
	{ TYPE_FLOAT, NULL, FALSE,  2 },		// Waves
	{ TYPE_INT, NULL, FALSE,  3 },		// Addative
	};
static ParamBlockDescID descVer1[] = {
	{ TYPE_FLOAT, NULL, FALSE,  0 },		// Falloff	
	{ TYPE_FLOAT, NULL, FALSE,  1 },		// Settle	
	{ TYPE_FLOAT, NULL, FALSE,  2 },		// Waves
	{ TYPE_INT, NULL, FALSE,  3 },		// Addative
	{ TYPE_INT, NULL, TRUE,  4 },		// Effect
	};
#define PBLOCK_LENGTH	5

#define CURRENT_VERSION	1

// Array of old versions
static ParamVersionDesc versions[] = {
	ParamVersionDesc(descVer0,3,0),
	};
#define NUM_OLDVERSIONS	1
static ParamVersionDesc curVersion(descVer1,PBLOCK_LENGTH,CURRENT_VERSION);

//---------------------------------------------------------------------
// UI stuff


class PaintRightMenu : public RightClickMenu {
	private:
		AFRMod *ep;
	public:
		void Init(RightClickMenuManager* manager, HWND hWnd, IPoint2 m);
		void Selected(UINT id);
		void SetMod(AFRMod *ep) { this->ep = ep; }
	};

void PaintRightMenu::Init(RightClickMenuManager* manager, HWND hWnd, IPoint2 m) {
		int flags1,flags2;
		flags1 = flags2 = MF_STRING;
		flags1 |= MF_CHECKED;


		manager->AddMenu(this, flags1, 0, "Move Normal");
		manager->AddMenu(this, flags2, 1, "Move XY Screen");
		manager->AddMenu(this, flags2, 2, "Move Z Screen");
		manager->AddMenu(this, flags2, 3, "Move X Local");
		manager->AddMenu(this, flags2, 4, "Move Y Local");
		manager->AddMenu(this, flags2, 5, "Move Z Local");
/*
		manager->AddMenu(this, MF_SEPARATOR, 0, NULL);
		manager->AddMenu(this, flags2, 10, "Str -32");
		manager->AddMenu(this, flags2, 11, "Str -16");
		manager->AddMenu(this, flags2, 12, "Str -8");
		manager->AddMenu(this, flags2, 13, "Str -4");
		manager->AddMenu(this, flags2, 14, "Str -2");
		manager->AddMenu(this, flags2, 15, "Str -1");
		manager->AddMenu(this, flags2, 16, "Str 1");
		manager->AddMenu(this, flags2, 17, "Str 2");
		manager->AddMenu(this, flags2, 18, "Str 4");
		manager->AddMenu(this, flags2, 19, "Str 8");
		manager->AddMenu(this, flags2, 20, "Str 16");
		manager->AddMenu(this, flags2, 21, "Str 32");
		manager->AddMenu(this, MF_SEPARATOR, 0, NULL);
		manager->AddMenu(this, flags2, 30, "Rad 1");
		manager->AddMenu(this, flags2, 31, "Rad 2");
		manager->AddMenu(this, flags2, 32, "Rad 4");
		manager->AddMenu(this, flags2, 33, "Rad 8");
		manager->AddMenu(this, flags2, 34, "Rad 16");
		manager->AddMenu(this, flags2, 35, "Rad 32");
		manager->AddMenu(this, flags2, 36, "Rad 64");
*/
		}
	

void PaintRightMenu::Selected(UINT id) {
//change ink type
	if (id<=5)
		{
		}
//chnage strength	
	else if (id<=21)
		{
		}
//change radius	
	else if (id<=36)
		{
		}
	}

PaintRightMenu pMenu;


//--- MapDlgProc -----------------------------------------------------

class PaintDlgProc : public ParamMapUserDlgProc {
	public:
		AFRMod *mod;		
		PaintDlgProc(AFRMod *m) {mod = m;}		
		BOOL DlgProc(TimeValue t,IParamMap *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);		
		void DeleteThis() {delete this;}
	};


BOOL PaintDlgProc::DlgProc(
		TimeValue t,IParamMap *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
	{
	int id = LOWORD(wParam);
	int code = HIWORD(wParam);

	switch (msg) {
		case WM_INITDIALOG:
			SendMessage(GetDlgItem(hWnd,IDC_PAINT),CC_COMMAND,CC_CMD_SET_TYPE,CBT_CHECK);
//fillout combo box
			mod->inkHWND = GetDlgItem(hWnd, IDC_INK);
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move Normal");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move XY Screen");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move Z Screen");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move XY Local");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move Z Local");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Smooth");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Tesselate");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Select Verts");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Select Faces");
			SendMessage( GetDlgItem(hWnd,IDC_INK), CB_SETCURSEL, mod->inkType , 0 );
//			mod->inkType = 0;

//			pMenu.SetMod(mod);
//			mod->ip->GetRightClickMenuManager()->Register(&pMenu);


			break;
//		case WM_DESTROY:
			// Don't leave in one of our modes!
//			mod->ip->GetRightClickMenuManager()->Unregister(&pMenu);
//			return FALSE;



		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_PAINT:
					if (mod->ip->GetCommandMode()->ID()==CID_FACEALIGNMAP) {
						mod->ip->SetStdCommandMode(CID_OBJMOVE);
					} else {
						mod->ip->SetCommandMode(mod->paintMode);
						}
					break;
				case IDC_INK: {
					if (code==CBN_SELCHANGE) {
						mod->inkType = SendMessage( GetDlgItem(hWnd,IDC_INK), CB_GETCURSEL, 0, 0 );
						}
					break;
					}

				}
			break;
		}
	return FALSE;
	}




//--- Affect region mod methods -------------------------------

AFRMod::AFRMod() 
	{
	MakeRefByID(
		FOREVER, PBLOCK_REF, 
		CreateParameterBlock(
			descVer0, PBLOCK_LENGTH, CURRENT_VERSION));
	
	sel[0] = 0;
	pblock->SetValue(PB_STR,0,strength);
	pblock->SetValue(PB_ERADIUS,0,eradius);
	pblock->SetValue(PB_HARDNESS,0,hardness);
	pblock->SetValue(PB_EFFECT,0,effect);
	inkType = 0;

	}

void AFRMod::EnterNormalAlign()
	{	
	SendMessage(GetDlgItem(pmapParam->GetHWnd(),IDC_PAINT),CC_COMMAND,CC_CMD_SET_STATE,1);
	}

void AFRMod::ExitNormalAlign()
	{	
	SendMessage(GetDlgItem(pmapParam->GetHWnd(),IDC_PAINT),CC_COMMAND,CC_CMD_SET_STATE,0);
	}


void AFRMod::BeginEditParams(
		IObjParam  *ip, ULONG flags,Animatable *prev)
	{
	this->ip = ip;
	// Add our sub object type
	TSTR type1(GetString(IDS_RB_AFRPOINTS));

	// Create sub object editing modes.



/*
	ModContextList mcList;
	INodeTab nodes;
	ip->GetModContexts(mcList,nodes);
	assert(nodes.Count());

	tnode = nodes[0];
*/

//	if (SelfNode) ReplaceReference(SELFNODE_REF,node,TRUE);
//	else MakeRefByID(FOREVER,SELFNODE_REF,node);
	


//	SelfNode = nodes[0];

//	NotifyDependents(FOREVER, 0, REFMSG_CHANGE);


	paintMode = new PaintMode(this,ip);

	
	TimeValue t = ip->GetTime();
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_BEGIN_EDIT);
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_MOD_DISPLAY_ON);
	SetAFlag(A_MOD_BEING_EDITED);

	pmapParam = CreateCPParamMap(
		descParam,PARAMDESC_LENGTH,
		pblock,
		ip,
		hInstance,
		MAKEINTRESOURCE(IDD_AFRPARAM),
		GetString(IDS_RB_PARAMETERS),
		0);	
	pmapParam->SetUserDlgProc(new PaintDlgProc(this));

	}

void AFRMod::EndEditParams(
		IObjParam *ip,ULONG flags,Animatable *next)
	{
	this->ip = NULL;
	TimeValue t = ip->GetTime();

	// NOTE: This flag must be cleared before sending the REFMSG_END_EDIT
	ClearAFlag(A_MOD_BEING_EDITED);

	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_END_EDIT);
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_MOD_DISPLAY_OFF);

	ip->DeleteMode(paintMode);
	delete paintMode; paintMode = NULL;

	DestroyCPParamMap(pmapParam);
	}

RefTargetHandle AFRMod::Clone(RemapDir& remap)
	{
	AFRMod *mod = new AFRMod();
	mod->ReplaceReference(PBLOCK_REF,pblock->Clone(remap));
//	mod->ReplaceReference(SELFNODE_REF,SelfNode->Clone(remap));
//	mod->SelfNode=NULL;
	return mod;
	}


void AFRMod::ModifyObject(
		TimeValue t, ModContext &mc, ObjectState *os, INode *node)
	{	
	int nv = os->obj->NumPoints();

	if (DeltaList.Count() == 0)
		{
		Point3 p(0.0f,0.0f,0.0f);
		BOOL b = FALSE;
		for (int i = 0; i < nv; i++)
			{
			DeltaList.Append(1,&p,1);
			TempList.Append(1,&p,1);
			SelectVertList.Append(1,&b,1);
			}
		}


	Interval valid = FOREVER;

	pblock->GetValue(PB_STR,t,strength,valid);		
	pblock->GetValue(PB_ERADIUS,t,eradius,valid);		
	pblock->GetValue(PB_HARDNESS,t,hardness,valid);		
	pblock->GetValue(PB_ADDATIVE,t,Addative,valid);		
	pblock->GetValue(PB_EFFECT,t,effect,valid);		
	

	strengthsquared = (float) fabs(strength);

	eradiussquared = eradius * eradius;
//object type nurbs or patch
//	if (os->obj->ClassID() == triObjectClassID)
//		{
		Interval iv = os->obj->ChannelValidity (t, GEOM_CHAN_NUM);
		iv &= os->obj->ChannelValidity (t, TOPO_CHAN_NUM);
		iv &= os->obj->ChannelValidity (t, SELECT_CHAN_NUM);
		iv &= os->obj->ChannelValidity (t, SUBSEL_TYPE_CHAN_NUM);
		iv &= os->obj->ChannelValidity (t, TEXMAP_CHAN_NUM);
		iv &= os->obj->ChannelValidity (t, VERT_COLOR_CHAN_NUM);

		TriObject *tobj = (TriObject*)os->obj;
		tobj->mesh.vertSel.ClearAll();

		if (inkType == 7)
			{
			tobj->mesh.selLevel = MESH_VERTEX;
			tobj->mesh.SetDispFlag(DISP_VERTTICKS | DISP_SELVERTS);
			}

		for (int i = 0; i<tobj->mesh.numVerts ;i++)
			{
			tobj->mesh.verts[i] += (DeltaList[i] + TempList[i]) * effect;
			if (SelectVertList[i])
				tobj->mesh.vertSel.Set(i);

			}
		os->obj->UpdateValidity (GEOM_CHAN_NUM, iv);
		os->obj->UpdateValidity (TOPO_CHAN_NUM, iv);
		os->obj->UpdateValidity (SELECT_CHAN_NUM, iv);
		os->obj->UpdateValidity (SUBSEL_TYPE_CHAN_NUM, iv);
		os->obj->UpdateValidity (TEXMAP_CHAN_NUM, iv);
		os->obj->UpdateValidity (VERT_COLOR_CHAN_NUM, iv);

/*		}
	else
		{
		AFRDeformer deformer(this);

//ebugPrint("In modifier\n");

		os->obj->Deform(&deformer, TRUE);

		os->obj->UpdateValidity(GEOM_CHAN_NUM, LocalValidity(t));
		}
*/

/*
	if (node->GetClassId)
		{

		AFRDeformer deformer(this);

//ebugPrint("In modifier\n");

		os->obj->Deform(&deformer, TRUE);

		os->obj->UpdateValidity(GEOM_CHAN_NUM, LocalValidity(t));
		}
	else
		{
//tesselate the object
//add deltas
		}
*/
	// Update our user interface parameter
//	UpdateUI(t);

	}

Interval AFRMod::LocalValidity(TimeValue t)
	{
	Interval iv = FOREVER;
	float v;
	Point3 pt;
//	pblock->GetValue(PB_FALLOFF,t,v,iv);
	iv.Set(t,t);
	return iv;
	}



RefTargetHandle AFRMod::GetReference(int i)
	{
	switch (i) {
		case PBLOCK_REF: return (RefTargetHandle)pblock;
		default: return NULL;
		}
	}

void AFRMod::SetReference(int i, RefTargetHandle rtarg)
	{
	switch (i) {
		case PBLOCK_REF: pblock = (IParamBlock*)rtarg; break;
		}
	}



RefResult AFRMod::NotifyRefChanged(
		Interval changeInt,RefTargetHandle hTarget, 
		PartID& partID, RefMessage message)
	{
	switch (message) {
		case REFMSG_GET_PARAM_DIM: {
			GetParamDim *gpd = (GetParamDim*)partID;
			switch (gpd->index) {
//				case PB_FALLOFF: gpd->dim = stdWorldDim; break;
				}
			return REF_STOP; 
			}

		case REFMSG_GET_PARAM_NAME: {
			GetParamName *gpn = (GetParamName*)partID;			
			switch (gpn->index) {
//				case PB_FALLOFF: gpn->name = GetString(IDS_AFR_FALLOFF); break;
				}
			return REF_STOP; 
			}


		}
	return REF_SUCCEED;
	}



#define POINTS_CHUNK	0x0010
#define INK_TYPE_CHUNK	0x0020
#define SELECT_VERTS_CHUNK	0x0030
#define SELECT_FACES_CHUNK	0x0040

IOResult AFRMod::Load(ILoad *iload)
	{
//	Modifier::Load(iload);
	ULONG nb;
	IOResult res = IO_OK;

	iload->RegisterPostLoadCallback(
		new ParamBlockPLCB(versions,NUM_OLDVERSIONS,&curVersion,this,0));

	
	DeltaList.ZeroCount();
	TempList.ZeroCount();
	SelectVertList.ZeroCount();
	

	
	Point3 zp(0.0f,0.0f,0.0f);

	while (IO_OK==(res=iload->OpenChunk())) {
		switch (iload->CurChunkID()) {
			case POINTS_CHUNK: {
				Point3 p;
				res = iload->Read(&p,sizeof(p),&nb);
				DeltaList.Append(1,&p,1);
				TempList.Append(1,&zp,1);
				break;
				}
			case SELECT_VERTS_CHUNK: {
				BOOL b;
				res = iload->Read(&b,sizeof(b),&nb);
				SelectVertList.Append(1,&b,1);
				break;
				}

			case INK_TYPE_CHUNK: {
				int ink;
				res = iload->Read(&ink,sizeof(ink),&nb);
				inkType = ink;
				break;
				}
			}
		iload->CloseChunk();
		if (res!=IO_OK)  return res;
		}	
	
	return IO_OK;
	}

IOResult AFRMod::Save(ISave *isave)
	{

//	Modifier::Save(isave);

	ULONG nb;

	isave->BeginChunk(INK_TYPE_CHUNK);
	isave->Write(&inkType,sizeof(inkType),&nb);
	isave->EndChunk();	

		
	for (int i = 0; i< DeltaList.Count(); i++)
		{
		Point3 p;
		p = DeltaList[i];
		isave->BeginChunk(POINTS_CHUNK);
		isave->Write(&p,sizeof(p),&nb);
		isave->EndChunk();	
		}

	for (i = 0; i< SelectVertList.Count(); i++)
		{
		BOOL b;
		b = SelectVertList[i];
		isave->BeginChunk(SELECT_VERTS_CHUNK);
		isave->Write(&b,sizeof(b),&nb);
		isave->EndChunk();	
		}


	
	return IO_OK;
	}




Point3 AFRDeformer::Map(int i, Point3 p)
	{
	if (i < mod->DeltaList.Count())
		{
//ebugPrint("in deformer %d point %f %f %f offset %f %f %f\n",i,p.x,p.y,p.z,mod->DeltaList[i].x,mod->DeltaList[i].y,mod->DeltaList[i].z);
		p += (mod->DeltaList[i] + mod->TempList[i]) * mod->effect;
		}
	return p;
	}